package cd.casic.server.controller;


import cd.casic.ci.process.dal.req.resource.ResourceQueryReq;
import cd.casic.ci.process.dal.req.resource.ResourceReq;
import cd.casic.ci.process.dal.resp.resource.ResourceResp;
import cd.casic.framework.commons.pojo.CommonResult;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import jakarta.validation.Valid;
import org.jetbrains.annotations.NotNull;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.ArrayList;
import java.util.List;

/**
 * @ClassName ResourceController
 * @Author hopeli
 * @Date 2025/5/10 10:57
 * @Version 1.0
 */

@RestController
@RequestMapping("/resource")
public class ResourceController {

    @PostMapping(path="/createResource")
    public CommonResult<String> createResource(@RequestBody @NotNull @Valid ResourceReq resourceReq){

//        String pipelineAuthHostId = envService.createEnv(env);

        String resourceId = "1";
        return CommonResult.success(resourceId);
    }


    @PostMapping(path="/deleteResource")
    public CommonResult<Void> deleteResource(@NotNull String resourceId){

//        envService.deleteEnv(envId);

        return CommonResult.success();
    }

    @PostMapping(path="/findResourceList")
    public CommonResult<List<ResourceResp>> findResourceList(@NotNull ResourceQueryReq query){

//        List<Env> envList = envService.findEnvList(envQuery);
        List<ResourceResp> resourceRespList = new ArrayList<>(0);
        ResourceResp resourceResp = new ResourceResp();
        resourceRespList.add(resourceResp);

        return CommonResult.success(resourceRespList);
    }



    @PostMapping(path="/updateResource")
    public CommonResult<Void> updateResource(@RequestBody @NotNull @Valid ResourceReq resourceReq){

//        this.envService.updateEnv(env);

        return CommonResult.success();
    }


    @PostMapping(path="/findResourcePage")
    public CommonResult<Page<ResourceResp>> findResourcePage(@RequestBody @NotNull @Valid ResourceQueryReq query){

//        Pagination<Env> envPage = envService.findEnvPage(envQuery);
        Page<ResourceResp> respPage = new Page<>();
        List<ResourceResp> resourceRespList = new ArrayList<>(0);
        ResourceResp resourceResp = new ResourceResp();
        resourceResp.setId("1");
        resourceRespList.add(resourceResp);
        respPage.setRecords(resourceRespList);
        return CommonResult.success(respPage);
    }

}
